commit 7be18951145653ea5122d102a365975c935f1295
Author: jpoubova <jpoubova@students.zcu.cz>
Date:   Sun Apr 5 22:56:24 2020 +0200

    Re #7728: Přidávání více dokumentů
    - do Solru se přidává 5 dokumentů
    - získání informací o všech dokumentech v Solru

diff --git a/be/fulltextsearch/src/main/java/cz/zcu/kiv/aswi/fulltextsearch/IndexController.java b/be/fulltextsearch/src/main/java/cz/zcu/kiv/aswi/fulltextsearch/IndexController.java
index 505d6a5..ca7928c 100644
--- a/be/fulltextsearch/src/main/java/cz/zcu/kiv/aswi/fulltextsearch/IndexController.java
+++ b/be/fulltextsearch/src/main/java/cz/zcu/kiv/aswi/fulltextsearch/IndexController.java
@@ -26,7 +26,7 @@ public class IndexController {
         String response;
 
         try {
-            response = "Found: " + solrService.query(query.getQuery());
+            response = solrService.query(query.getQuery());
         } catch (IOException e) {
             response = "IOException";
         } catch (SolrServerException e) {
@@ -55,18 +55,23 @@ public class IndexController {
 
     @GetMapping("/documents")
     public List<DocumentResponse> uploadFile() {
+        List<DocumentResponse> response = new ArrayList<>();
 
-        // TODO : získat všechny uložené dokumenty v systému
-
-        return new ArrayList<>() {
-            {
-                add(new DocumentResponse("soap-ch_knihovna_ascher-zeitung-1866-06-16-n24_0855", 1));
-                add(new DocumentResponse("soap-ch_knihovna_ascher-zeitung-1866-09-15-n37_1365", 2));
-                add(new DocumentResponse("soap-ch_knihovna_ascher-zeitung-1866-08-25-n34_1255", 3));
-                add(new DocumentResponse("soap-ch_knihovna_ascher-zeitung-1866-07-07-n27_0980", 4));
+        try {
+            List<String> filenames = solrService.listAllFiles();
+            int id = 0; // todo
+            for (String filename: filenames) {
+                response.add(new DocumentResponse(filename, id++));
             }
-        };
+        } catch (IOException e) {
+            // todo
+        } catch (SolrServerException e) {
+            // todo
+        } catch (Exception e) {
+            // todo
+        }
 
+        return response;
     }
 
 
diff --git a/be/fulltextsearch/src/main/java/cz/zcu/kiv/aswi/fulltextsearch/SolrService.java b/be/fulltextsearch/src/main/java/cz/zcu/kiv/aswi/fulltextsearch/SolrService.java
index 3e7817d..3062ec9 100644
--- a/be/fulltextsearch/src/main/java/cz/zcu/kiv/aswi/fulltextsearch/SolrService.java
+++ b/be/fulltextsearch/src/main/java/cz/zcu/kiv/aswi/fulltextsearch/SolrService.java
@@ -7,15 +7,22 @@ import org.apache.solr.client.solrj.SolrServerException;
 import org.apache.solr.client.solrj.impl.HttpSolrClient;
 import org.apache.solr.client.solrj.impl.XMLResponseParser;
 import org.apache.solr.client.solrj.response.QueryResponse;
+import org.apache.solr.common.SolrDocument;
 import org.apache.solr.common.SolrDocumentList;
 
 import javax.xml.bind.JAXBException;
+import java.io.File;
 import java.io.IOException;
+import java.util.ArrayList;
+import java.util.HashSet;
+import java.util.List;
+import java.util.Set;
 
 public class SolrService {
 
     private HttpSolrClient solrClient;
-    private final String CORE_NAME = "documents";
+    private static final String CORE_NAME = "documents";
+    public static final String DATA_DIR = "data/";
 
     public SolrService() {
         connect();
@@ -27,11 +34,16 @@ public class SolrService {
         solrClient.setParser(new XMLResponseParser());
     }
 
-    public void addAllDocuments() throws IOException, SolrServerException, JAXBException { // todo all
+    public void addAllDocuments() throws IOException, SolrServerException, JAXBException {
         XMLLoader xmlLoader = new XMLLoader();
-        String filename = "soap-ch_knihovna_ascher-zeitung-1866-06-09-n23_0815.xml";
-        PcGts doc = xmlLoader.loadFile(filename);
-        addDocument(doc);
+
+        String dataFile = getClass().getClassLoader().getResource(DATA_DIR).getFile();
+        File[] files = new File(dataFile).listFiles((dir, name) -> name.toLowerCase().endsWith(".xml"));
+
+        for (File file: files) {
+            PcGts doc = xmlLoader.loadFile(file.getName());
+            addDocument(doc);
+        }
     }
 
     public void deleteAll() throws IOException, SolrServerException {
@@ -45,11 +57,16 @@ public class SolrService {
         QueryResponse response = solrClient.query(solrQuery);
 
         SolrDocumentList docList = response.getResults();
-        return Long.toString(docList.getNumFound());
+        Set<String> ids = getUniqueIds(docList);
+
+        return "Found in " + ids.size() + " documents with ids=" + String.join(", ", ids);
     }
 
     private void addDocument(PcGts document) throws IOException, SolrServerException {
-        for (TextRegion textRegion: document.getPage().getTextRegions()) {
+        List<TextRegion> regions = document.getPage().getTextRegions();
+        if (regions == null || regions.size() == 0) return;
+
+        for (TextRegion textRegion: regions) {
             addTextRegion(textRegion);
         }
     }
@@ -64,4 +81,24 @@ public class SolrService {
         q.setRows(0);  // don't actually request any data
         return "Number of documents in core: " + solrClient.query(q).getResults().getNumFound();
     }
+
+    public List<String> listAllFiles() throws IOException, SolrServerException {
+        SolrQuery solrQuery = new SolrQuery();
+        solrQuery.set("q", "file:*");
+        solrQuery.setRows(300); // todo not a magic number!
+        SolrDocumentList docList = solrClient.query(solrQuery).getResults();
+
+        Set<String> ids = getUniqueIds(docList);
+        return new ArrayList<>(ids);
+    }
+
+    private Set<String> getUniqueIds(SolrDocumentList documents) {
+        Set<String> ids = new HashSet<>();
+        for (SolrDocument document: documents) {
+            String id = document.getFieldValue("file").toString();
+            ids.add(id);
+        }
+
+        return ids;
+    }
 }
diff --git a/be/fulltextsearch/src/main/java/cz/zcu/kiv/aswi/fulltextsearch/XMLLoader.java b/be/fulltextsearch/src/main/java/cz/zcu/kiv/aswi/fulltextsearch/XMLLoader.java
index 92b95d3..629ac55 100644
--- a/be/fulltextsearch/src/main/java/cz/zcu/kiv/aswi/fulltextsearch/XMLLoader.java
+++ b/be/fulltextsearch/src/main/java/cz/zcu/kiv/aswi/fulltextsearch/XMLLoader.java
@@ -11,7 +11,7 @@ import java.util.logging.Level;
 public class XMLLoader {
 
     public PcGts loadFile(String filename) throws JAXBException {
-        InputStream file = getClass().getClassLoader().getResourceAsStream(filename);
+        InputStream file = getClass().getClassLoader().getResourceAsStream(SolrService.DATA_DIR + filename);
 
         JAXBContext jaxbContext = JAXBContext.newInstance(PcGts.class);
         Unmarshaller jaxbUnmarshaller = jaxbContext.createUnmarshaller();
diff --git a/be/fulltextsearch/src/main/java/cz/zcu/kiv/aswi/fulltextsearch/document/Page.java b/be/fulltextsearch/src/main/java/cz/zcu/kiv/aswi/fulltextsearch/document/Page.java
index ef2b1e0..a571358 100644
--- a/be/fulltextsearch/src/main/java/cz/zcu/kiv/aswi/fulltextsearch/document/Page.java
+++ b/be/fulltextsearch/src/main/java/cz/zcu/kiv/aswi/fulltextsearch/document/Page.java
@@ -27,6 +27,8 @@ public class Page {
 
     public void setId(String id) {
         this.id = id;
+        if (this.textRegions == null) return;
+
         for (int i = 0; i < textRegions.size(); i++) {
             TextRegion textRegion = textRegions.get(i);
             textRegion.setId(id + "_" + i +"_region");
